VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmRegistry 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   4380
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9255
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4380
   ScaleWidth      =   9255
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton CmdEnumValues 
      Caption         =   "Enum Values"
      Height          =   375
      Left            =   2550
      TabIndex        =   7
      Top             =   3555
      Width           =   1230
   End
   Begin VB.TextBox TxtValueName 
      Height          =   285
      Left            =   6240
      TabIndex        =   3
      Top             =   360
      Width           =   3015
   End
   Begin RichTextLib.RichTextBox RtfBox 
      Height          =   2730
      Left            =   0
      TabIndex        =   4
      Top             =   720
      Width           =   9285
      _ExtentX        =   16378
      _ExtentY        =   4815
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmRegistry.frx":0000
   End
   Begin VB.ComboBox CboRoot 
      Height          =   315
      Left            =   1440
      TabIndex        =   2
      Top             =   360
      Width           =   3135
   End
   Begin VB.CommandButton CmdSetValue 
      Caption         =   "Write a Value"
      Height          =   375
      Left            =   6375
      TabIndex        =   10
      Top             =   3555
      Visible         =   0   'False
      Width           =   1230
   End
   Begin VB.CommandButton CmdDeleteValue 
      Caption         =   "Delete Value"
      Height          =   375
      Left            =   5100
      TabIndex        =   9
      Top             =   3555
      Width           =   1230
   End
   Begin VB.CommandButton CmdDeleteKey 
      Caption         =   "Delete Key"
      Height          =   375
      Left            =   7650
      TabIndex        =   11
      Top             =   3555
      Width           =   1230
   End
   Begin VB.CommandButton CmdEnumSubKey 
      Caption         =   "Enum Subkeys"
      Height          =   375
      Left            =   1275
      TabIndex        =   6
      Top             =   3555
      Width           =   1230
   End
   Begin VB.CommandButton CmdGetValue 
      Caption         =   "Show Value"
      Height          =   375
      Left            =   3825
      TabIndex        =   8
      Top             =   3555
      Width           =   1230
   End
   Begin VB.CommandButton CmdExists 
      Caption         =   "Check exists"
      Height          =   375
      Left            =   0
      TabIndex        =   5
      Top             =   3555
      Width           =   1230
   End
   Begin VB.TextBox txtKey 
      Height          =   285
      Left            =   1440
      TabIndex        =   1
      Top             =   0
      Width           =   7815
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Value Name"
      Height          =   195
      Left            =   5040
      TabIndex        =   14
      Top             =   405
      Width           =   870
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Registry Root"
      Height          =   195
      Left            =   120
      TabIndex        =   13
      Top             =   405
      Width           =   960
   End
   Begin VB.Label lblRet 
      Height          =   135
      Left            =   120
      TabIndex        =   12
      Top             =   4080
      Width           =   1455
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Registry Key"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   45
      Width           =   885
   End
End
Attribute VB_Name = "frmRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim searchIn As Long


Private Sub CboRoot_Click()
    Select Case CboRoot.List(CboRoot.ListIndex)
        Case "HKEY_CLASSES_ROOT"
            searchIn = HKEY_CLASSES_ROOT
        Case "HKEY_CURRENT_USER"
            searchIn = HKEY_CURRENT_USER
        Case "HKEY_LOCAL_MACHINE"
            searchIn = HKEY_LOCAL_MACHINE
        Case "HKEY_USERS"
            searchIn = HKEY_USERS
        Case "HKEY_PERFORMANCE_DATA"
            searchIn = HKEY_PERFORMANCE_DATA
        Case "HKEY_CURRENT_CONFIG"
            searchIn = HKEY_CURRENT_CONFIG
        Case "HKEY_DYN_DATA"
            searchIn = HKEY_DYN_DATA
        End Select
End Sub

Private Sub CmdDeleteKey_Click()
   If MRegistry.CheckRegistryKey(searchIn, txtKey.Text) Then
        MRegistry.DeleteRegistryKey searchIn, txtKey.Text
        MsgBox "Key deleted"
   Else
        MsgBox "Key not found"
   End If
End Sub

Private Sub CmdDeleteValue_Click()
    If MRegistry.DeleteRegistryValue(searchIn, txtKey.Text, TxtValueName.Text) Then
        MsgBox "Value deleted"
    Else
        MsgBox "Did not delete the value"
    End If
End Sub

Private Sub CmdEnumSubKey_Click()
    Dim keyColl As Collection
    Set keyColl = MRegistry.EnumRegistryKeys(searchIn, txtKey.Text)
    Dim strK As Variant
    Dim strSource As String
    strSource = IIf(txtKey.Text = "", CboRoot.Text, txtKey.Text)
    RtfBox.Text = "SubKeys of """ & strSource & """:"
    For Each strK In keyColl
        RtfBox.Text = RtfBox.Text & vbCrLf & strK
    Next
End Sub

Private Sub CmdEnumValues_Click()
    Dim keyColl As Collection
    Set keyColl = MRegistry.EnumRegistryValues(searchIn, txtKey.Text)
    Dim strK As Variant
    Dim strSource As String
    strSource = IIf(txtKey.Text = "", CboRoot.Text, txtKey.Text)
    RtfBox.Text = "Name Values of """ & strSource & """:"
    Dim Counter As Integer
    For Each strK In keyColl
        RtfBox.Text = RtfBox.Text & vbCrLf
        For Counter = 0 To UBound(strK)
            RtfBox.Text = RtfBox.Text & strK(Counter) & "  "
        Next
        
    Next
End Sub

Private Sub CmdExists_Click()
    Dim strSource As String
    strSource = IIf(txtKey.Text = "", CboRoot.Text, txtKey.Text)
    If MRegistry.CheckRegistryKey(searchIn, txtKey.Text) Then
        lblRet.Caption = "Exist Key """ & strSource & ""
    Else
        lblRet.Caption = "Not Found Key """ & strSource & ""
    End If
End Sub

Private Sub CmdGetValue_Click()
If Len(TxtValueName.Text) > 0 Then
    lblRet.Caption = "Value=" & MRegistry.GetRegistryValue(searchIn, txtKey.Text, TxtValueName.Text)
Else
    MsgBox "In VAlue name you should put the identifier of the value you're looking for..."
End If
End Sub

Private Sub Form_Load()
    lblRet.AutoSize = True
    CboRoot.AddItem "All"
    CboRoot.AddItem "HKEY_CLASSES_ROOT"
    CboRoot.AddItem "HKEY_CURRENT_USER"
    CboRoot.AddItem "HKEY_LOCAL_MACHINE"
    CboRoot.AddItem "HKEY_USERS"
    CboRoot.AddItem "HKEY_PERFORMANCE_DATA"
    CboRoot.AddItem "HKEY_CURRENT_CONFIG"
    CboRoot.AddItem "HKEY_DYN_DATA"
End Sub
